<html>
<head>
<title>OgreGLRenderSystem.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLRenderSystem.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLRenderSystem_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLRenderSystem_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLRenderSystem_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlatform_8h.html">OgrePlatform.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystem_8h.html">OgreRenderSystem.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLHardwareBufferManager_8h.html">OgreGLHardwareBufferManager.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLGpuProgramManager_8h.html">OgreGLGpuProgramManager.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040     
<a name="l00041"></a>00041     <span class="keyword">class </span>GLSLProgramFactory;
<a name="l00042"></a>00042 
<a name="l00046"></a><a class="code" href="classOgre_1_1GLRenderSystem.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLRenderSystem.html" title="Implementation of GL as a rendering system.">GLRenderSystem</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">private</span>:
<a name="l00050"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a6bf15e083170d5ad953a2d273c723171">00050</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLRenderSystem.html#a6bf15e083170d5ad953a2d273c723171" title="Rendering loop control.">mStopRendering</a>;
<a name="l00051"></a>00051 
<a name="l00055"></a><a class="code" href="OgreGLRenderSystem_8h.html#a737b417f16ea225cf15e8d4c23df53dc">00055</a> <span class="preprocessor">        #define MAX_LIGHTS 8</span>
<a name="l00056"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#aa4b66c5444cc5272418b7cfcf071aece">00056</a> <span class="preprocessor"></span>        <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* mLights[<a class="code" href="OgreGLRenderSystem_8h.html#a737b417f16ea225cf15e8d4c23df53dc" title="Array of up to 8 lights, indexed as per API Note that a null value indicates a free slot...">MAX_LIGHTS</a>];
<a name="l00057"></a>00057 
<a name="l00059"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a4fac54ead1cef65aeb81b1d656802e22">00059</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#a4fac54ead1cef65aeb81b1d656802e22" title="View matrix to set world against.">mViewMatrix</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a48a06239cb6a49005ab266ece1ee65c7">00060</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#a48a06239cb6a49005ab266ece1ee65c7">mWorldMatrix</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#aec704e5edaeb7fe974ba4a0e73848c38">00061</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#aec704e5edaeb7fe974ba4a0e73848c38">mTextureMatrix</a>;
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a73161095cd10735da21bfea9a01472e0">00064</a>         <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#a73161095cd10735da21bfea9a01472e0" title="Last min &amp; mip filtering options, so we can combine them.">mMinFilter</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#adac5018adaeb854dec7f8c41cc4b6438">00065</a>         <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#adac5018adaeb854dec7f8c41cc4b6438">mMipFilter</a>;
<a name="l00066"></a>00066 
<a name="l00068"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#adf710bf75fa0e96246bc55a7f592147e">00068</a>         <span class="keywordtype">size_t</span> mTextureCoordIndex[<a class="code" href="OgreConfig_8h.html#a1c5fd80e6e0f2f85d6facbe1ec8eb5a4" title="Define max number of texture layers allowed per pass on any card.">OGRE_MAX_TEXTURE_LAYERS</a>];
<a name="l00069"></a>00069 
<a name="l00071"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#aae119c4beeeb7fb5a0f5b1c03c5a821c">00071</a>         GLenum mTextureTypes[<a class="code" href="OgreConfig_8h.html#a1c5fd80e6e0f2f85d6facbe1ec8eb5a4" title="Define max number of texture layers allowed per pass on any card.">OGRE_MAX_TEXTURE_LAYERS</a>];
<a name="l00072"></a>00072 
<a name="l00074"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a9ae06e6f262bc165c12cdc9592a83514">00074</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1GLRenderSystem.html#a9ae06e6f262bc165c12cdc9592a83514" title="Number of fixed-function texture units.">mFixedFunctionTextureUnits</a>;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076         <span class="keywordtype">void</span> initConfigOptions(<span class="keywordtype">void</span>);
<a name="l00077"></a>00077         <span class="keywordtype">void</span> initInputDevices(<span class="keywordtype">void</span>);
<a name="l00078"></a>00078         <span class="keywordtype">void</span> processInputDevices(<span class="keywordtype">void</span>);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080         <span class="keywordtype">void</span> setGLLight(<span class="keywordtype">size_t</span> index, <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* lt);
<a name="l00081"></a>00081         <span class="keywordtype">void</span> makeGLMatrix(GLfloat gl_matrix[16], <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; m);
<a name="l00082"></a>00082  
<a name="l00083"></a>00083         GLint getBlendMode(<a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> ogreBlend) <span class="keyword">const</span>;
<a name="l00084"></a>00084         GLint getTextureAddressingMode(<a class="code" href="classOgre_1_1TextureUnitState.html#a47c5a9f4fc08159b99bdc51103bcf852" title="Texture addressing modes - default is TAM_WRAP.">TextureUnitState::TextureAddressingMode</a> tam) <span class="keyword">const</span>;
<a name="l00085"></a>00085                 <span class="keywordtype">void</span> initialiseContext(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* primary);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087         <span class="keywordtype">void</span> setLights();
<a name="l00088"></a>00088 
<a name="l00090"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#aa8a90a9af03e667cbf250f23c30fa2fe">00090</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLRenderSystem.html#aa8a90a9af03e667cbf250f23c30fa2fe" title="Store last depth write state.">mDepthWrite</a>;
<a name="l00092"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a6033caf1eddcabeef54efd705c75692f">00092</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#a6033caf1eddcabeef54efd705c75692f" title="Store last stencil mask state.">mStencilMask</a>;
<a name="l00094"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#ad7af2dd66a03230b58360ee9ebe349de">00094</a>         <span class="keywordtype">bool</span> mColourWrite[4];
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         GLint convertCompareFunction(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func) <span class="keyword">const</span>;
<a name="l00097"></a>00097         GLint convertStencilOp(<a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> op, <span class="keywordtype">bool</span> invert = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00098"></a>00098 
<a name="l00100"></a>00100         GLfloat _getCurrentAnisotropy(<span class="keywordtype">size_t</span> unit);
<a name="l00101"></a>00101         
<a name="l00103"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#afe2052a28b0590d64d62dcf2956999b4">00103</a>         <a class="code" href="classOgre_1_1GLSupport.html">GLSupport</a>* <a class="code" href="classOgre_1_1GLRenderSystem.html#afe2052a28b0590d64d62dcf2956999b4" title="GL support class, used for creating windows etc.">mGLSupport</a>;
<a name="l00104"></a>00104         
<a name="l00106"></a>00106         <span class="keywordtype">void</span> setGLLightPositionDirection(<a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* lt, GLenum lightindex);
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#afbcc824f177e64ae0ec373cd06591b4d">00108</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLRenderSystem.html#afbcc824f177e64ae0ec373cd06591b4d">mUseAutoTextureMatrix</a>;
<a name="l00109"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a971eb2d822ab12db90f1fbe0392ca4d4">00109</a>         GLfloat mAutoTextureMatrix[16];
<a name="l00110"></a>00110 
<a name="l00112"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a01d9f1b57cc53680a9d0b50b063831aa">00112</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLRenderSystem.html#a01d9f1b57cc53680a9d0b50b063831aa" title="Check if the GL system has already been initialised.">mGLInitialised</a>;
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#afb5d5c238079ce1f4370dc3088c148e6">00114</a>         <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>* <a class="code" href="classOgre_1_1GLRenderSystem.html#afb5d5c238079ce1f4370dc3088c148e6">mHardwareBufferManager</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a489b7d773192d0a7af1a851163a276ac">00115</a>         <a class="code" href="classOgre_1_1GLGpuProgramManager.html">GLGpuProgramManager</a>* <a class="code" href="classOgre_1_1GLRenderSystem.html#a489b7d773192d0a7af1a851163a276ac">mGpuProgramManager</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a00975b3f6d2d3d20054bf57ecae7b497">00116</a>         <a class="code" href="classOgre_1_1GLSLProgramFactory.html" title="Factory class for GLSL programs.">GLSLProgramFactory</a>* <a class="code" href="classOgre_1_1GLRenderSystem.html#a00975b3f6d2d3d20054bf57ecae7b497">mGLSLProgramFactory</a>;
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a0ed46fa148891beac57c2468d45fd995">00118</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1GLRenderSystem.html#a0ed46fa148891beac57c2468d45fd995">mCurrentLights</a>;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120         GLuint getCombinedMinMipFilter(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#aa1eede369f4ba54cb166efafc8d3539e">00122</a>         <a class="code" href="classOgre_1_1GLGpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLGpuProgram</a>* <a class="code" href="classOgre_1_1GLRenderSystem.html#aa1eede369f4ba54cb166efafc8d3539e">mCurrentVertexProgram</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#ab46dd74c60b9da6e0fb5e8c28793b6b7">00123</a>         <a class="code" href="classOgre_1_1GLGpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLGpuProgram</a>* <a class="code" href="classOgre_1_1GLRenderSystem.html#ab46dd74c60b9da6e0fb5e8c28793b6b7">mCurrentFragmentProgram</a>;
<a name="l00124"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a63f6bbfceb5f39d91fb00a248f7c29b9">00124</a>         <a class="code" href="classOgre_1_1GLGpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLGpuProgram</a>* <a class="code" href="classOgre_1_1GLRenderSystem.html#a63f6bbfceb5f39d91fb00a248f7c29b9">mCurrentGeometryProgram</a>;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126         <span class="comment">/* The main GL context - main thread only */</span>
<a name="l00127"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a72ebe911e2d2273bec95c45fa734e0d7">00127</a>         <a class="code" href="classOgre_1_1GLContext.html" title="Class that encapsulates an GL context.">GLContext</a> *<a class="code" href="classOgre_1_1GLRenderSystem.html#a72ebe911e2d2273bec95c45fa734e0d7">mMainContext</a>;
<a name="l00128"></a>00128         <span class="comment">/* The current GL context  - main thread only */</span>
<a name="l00129"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#af6b876972d358aa674d85322be84b4dd">00129</a>         <a class="code" href="classOgre_1_1GLContext.html" title="Class that encapsulates an GL context.">GLContext</a> *<a class="code" href="classOgre_1_1GLRenderSystem.html#af6b876972d358aa674d85322be84b4dd">mCurrentContext</a>;
<a name="l00130"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#ad513df0171676484129fd8671d592368">00130</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;GLContext*&gt;::type</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#ad513df0171676484129fd8671d592368">GLContextList</a>;
<a name="l00132"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a24f25294368c4ef1a11dee9045e72755">00132</a>         <a class="code" href="classOgre_1_1GLRenderSystem.html#ad513df0171676484129fd8671d592368">GLContextList</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#a24f25294368c4ef1a11dee9045e72755" title="List of background thread contexts.">mBackgroundContextList</a>;
<a name="l00133"></a>00133 
<a name="l00139"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a293971e3a7cd7701dc6700f7e0381389">00139</a>         <a class="code" href="classOgre_1_1GLRTTManager.html" title="Manager/factory for RenderTextures.">GLRTTManager</a> *<a class="code" href="classOgre_1_1GLRenderSystem.html#a293971e3a7cd7701dc6700f7e0381389" title="Manager object for creating render textures.">mRTTManager</a>;
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#add9e0674697bcdbd901c5e31b1fcede4">00141</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#add9e0674697bcdbd901c5e31b1fcede4">mActiveTextureUnit</a>;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143         <span class="comment">// local data members of _render that were moved here to improve performance</span>
<a name="l00144"></a>00144         <span class="comment">// (save allocations)</span>
<a name="l00145"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#acf87997a329260068e9d94a1a7941243">00145</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;GLuint&gt;::type</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#acf87997a329260068e9d94a1a7941243">mRenderAttribsBound</a>;
<a name="l00146"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#aac7cd483ff4b7d5b652d802baa85d0ba">00146</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;GLuint&gt;::type</a> <a class="code" href="classOgre_1_1GLRenderSystem.html#aac7cd483ff4b7d5b652d802baa85d0ba">mRenderInstanceAttribsBound</a>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="keyword">protected</span>:
<a name="l00150"></a>00150         <span class="keywordtype">void</span> setClipPlanesImpl(<span class="keyword">const</span> <a class="code" href="group__Math.html#gae00d718daa48567f6c010aad9d6dd92c">PlaneList</a>&amp; clipPlanes);
<a name="l00151"></a>00151         <span class="keywordtype">bool</span> activateGLTextureUnit(<span class="keywordtype">size_t</span> unit);
<a name="l00152"></a>00152         <span class="keywordtype">void</span> bindVertexElementToGpu( <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a> &amp;elem, <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> vertexBuffer,
<a name="l00153"></a>00153                 <span class="keyword">const</span> <span class="keywordtype">size_t</span> vertexStart, 
<a name="l00154"></a>00154                 <a class="code" href="structOgre_1_1vector.html">vector&lt;GLuint&gt;::type</a> &amp;attribsBound, <a class="code" href="structOgre_1_1vector.html">vector&lt;GLuint&gt;::type</a> &amp;instanceAttribsBound );
<a name="l00155"></a>00155     <span class="keyword">public</span>:
<a name="l00156"></a>00156         <span class="comment">// Default constructor / destructor</span>
<a name="l00157"></a>00157         <a class="code" href="classOgre_1_1GLRenderSystem.html" title="Implementation of GL as a rendering system.">GLRenderSystem</a>();
<a name="l00158"></a>00158         ~<a class="code" href="classOgre_1_1GLRenderSystem.html" title="Implementation of GL as a rendering system.">GLRenderSystem</a>();
<a name="l00159"></a>00159 
<a name="l00160"></a>00160         <span class="comment">// ----------------------------------</span>
<a name="l00161"></a>00161         <span class="comment">// Overridden RenderSystem functions</span>
<a name="l00162"></a>00162         <span class="comment">// ----------------------------------</span>
<a name="l00166"></a>00166 <span class="comment"></span>        <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00170"></a>00170         <a class="code" href="group__General.html#gafba22dbf34cd07633293ddba65ee6add">ConfigOptionMap</a>&amp; getConfigOptions(<span class="keywordtype">void</span>);
<a name="l00174"></a>00174         <span class="keywordtype">void</span> setConfigOption(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value);
<a name="l00178"></a>00178         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfigOptions(<span class="keywordtype">void</span>);
<a name="l00182"></a>00182         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* _initialise(<span class="keywordtype">bool</span> autoCreateWindow, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle = <span class="stringliteral">&quot;OGRE Render Window&quot;</span>);
<a name="l00186"></a>00186                 <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* createRenderSystemCapabilities() <span class="keyword">const</span>;
<a name="l00190"></a>00190                 <span class="keywordtype">void</span> initialiseFromRenderSystemCapabilities(<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* caps, <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>* primary);
<a name="l00194"></a>00194         <span class="keywordtype">void</span> reinitialise(<span class="keywordtype">void</span>); <span class="comment">// Used if settings changed mid-rendering</span>
<a name="l00198"></a>00198 <span class="comment"></span>        <span class="keywordtype">void</span> shutdown(<span class="keywordtype">void</span>);
<a name="l00199"></a>00199 
<a name="l00203"></a>00203         <span class="keywordtype">void</span> setAmbientLight(<span class="keywordtype">float</span> r, <span class="keywordtype">float</span> g, <span class="keywordtype">float</span> b);
<a name="l00207"></a>00207         <span class="keywordtype">void</span> setShadingType(<a class="code" href="group__General.html#ga7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> so);
<a name="l00211"></a>00211         <span class="keywordtype">void</span> setLightingEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00212"></a>00212         
<a name="l00214"></a>00214         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* _createRenderWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00215"></a>00215             <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams = 0);
<a name="l00216"></a>00216 
<a name="l00218"></a>00218         <span class="keywordtype">bool</span> _createRenderWindows(<span class="keyword">const</span> <a class="code" href="group__General.html#ga7a03bf97326d0d0385b91a74e2c51c5e" title="Render window creation parameters container.">RenderWindowDescriptionList</a>&amp; renderWindowDescriptions, 
<a name="l00219"></a>00219             <a class="code" href="group__General.html#ga1d8e92efee48ea10e75189c8efa6ec51" title="Render window container.">RenderWindowList</a>&amp; createdWindows);
<a name="l00220"></a>00220 
<a name="l00222"></a>00222         <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>* _createDepthBufferFor( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *renderTarget );
<a name="l00223"></a>00223 
<a name="l00225"></a>00225         <span class="keywordtype">void</span> _getDepthStencilFormatFor( GLenum internalColourFormat, GLenum *depthFormat,
<a name="l00226"></a>00226                                         GLenum *stencilFormat );
<a name="l00227"></a>00227         
<a name="l00229"></a>00229         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a> * createMultiRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name); 
<a name="l00230"></a>00230         
<a name="l00234"></a>00234         <span class="keywordtype">void</span> destroyRenderWindow(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* pWin);
<a name="l00238"></a>00238         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getErrorDescription(<span class="keywordtype">long</span> errorNumber) <span class="keyword">const</span>;
<a name="l00239"></a>00239 
<a name="l00243"></a>00243         <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> getColourVertexElementType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00247"></a>00247         <span class="keywordtype">void</span> setNormaliseNormals(<span class="keywordtype">bool</span> normalise);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249         <span class="comment">// -----------------------------</span>
<a name="l00250"></a>00250         <span class="comment">// Low-level overridden members</span>
<a name="l00251"></a>00251         <span class="comment">// -----------------------------</span>
<a name="l00255"></a>00255 <span class="comment"></span>        <span class="keywordtype">void</span> _useLights(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; lights, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> limit);
<a name="l00259"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#a1717dc0498bad4ec6213dcf2858ace7c">00259</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLRenderSystem.html#a1717dc0498bad4ec6213dcf2858ace7c" title="See RenderSystem.">areFixedFunctionLightsInViewSpace</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00263"></a>00263         <span class="keywordtype">void</span> _setWorldMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m);
<a name="l00267"></a>00267         <span class="keywordtype">void</span> _setViewMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m);
<a name="l00271"></a>00271         <span class="keywordtype">void</span> _setProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m);
<a name="l00275"></a>00275         <span class="keywordtype">void</span> _setSurfaceParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;ambient,
<a name="l00276"></a>00276             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;diffuse, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;specular,
<a name="l00277"></a>00277             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;emissive, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> shininess,
<a name="l00278"></a>00278             <a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a> tracking);
<a name="l00282"></a>00282         <span class="keywordtype">void</span> _setPointParameters(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> size, <span class="keywordtype">bool</span> attenuationEnabled, 
<a name="l00283"></a>00283             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> constant, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linear, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> quadratic, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> minSize, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> maxSize);
<a name="l00287"></a>00287         <span class="keywordtype">void</span> _setPointSpritesEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00291"></a>00291         <span class="keywordtype">void</span> _setTexture(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">bool</span> enabled, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> &amp;tex);
<a name="l00295"></a>00295         <span class="keywordtype">void</span> _setTextureCoordSet(<span class="keywordtype">size_t</span> stage, <span class="keywordtype">size_t</span> index);
<a name="l00299"></a>00299         <span class="keywordtype">void</span> _setTextureCoordCalculation(<span class="keywordtype">size_t</span> stage, <a class="code" href="group__RenderSystem.html#gaa9c06899edc6b7aed7bf3b29abe9bb31" title="Enum describing the ways to generate texture coordinates.">TexCoordCalcMethod</a> m, 
<a name="l00300"></a>00300             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>* frustum = 0);
<a name="l00304"></a>00304         <span class="keywordtype">void</span> _setTextureBlendMode(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a>&amp; bm);
<a name="l00308"></a>00308         <span class="keywordtype">void</span> _setTextureAddressingMode(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html" title="Texture addressing mode for each texture coordinate.">TextureUnitState::UVWAddressingMode</a>&amp; uvw);
<a name="l00312"></a>00312         <span class="keywordtype">void</span> _setTextureBorderColour(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour);
<a name="l00316"></a>00316         <span class="keywordtype">void</span> _setTextureMipmapBias(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">float</span> bias);
<a name="l00320"></a>00320         <span class="keywordtype">void</span> _setTextureMatrix(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; xform);
<a name="l00324"></a>00324         <span class="keywordtype">void</span> _setSceneBlending(<a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op );
<a name="l00328"></a>00328         <span class="keywordtype">void</span> _setSeparateSceneBlending(<a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactorAlpha, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactorAlpha, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> alphaOp );
<a name="l00332"></a>00332         <span class="keywordtype">void</span> _setSceneBlendingOperation(<a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op);
<a name="l00336"></a>00336         <span class="keywordtype">void</span> _setSeparateSceneBlendingOperation(<a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> alphaOp);
<a name="l00340"></a>00340         <span class="keywordtype">void</span> _setAlphaRejectSettings(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> value, <span class="keywordtype">bool</span> alphaToCoverage);
<a name="l00344"></a>00344         <span class="keywordtype">void</span> _setViewport(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp);
<a name="l00348"></a>00348         <span class="keywordtype">void</span> _beginFrame(<span class="keywordtype">void</span>);
<a name="l00352"></a>00352         <span class="keywordtype">void</span> _endFrame(<span class="keywordtype">void</span>);
<a name="l00356"></a>00356         <span class="keywordtype">void</span> _setCullingMode(<a class="code" href="group__General.html#gac173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mode);
<a name="l00360"></a>00360         <span class="keywordtype">void</span> _setDepthBufferParams(<span class="keywordtype">bool</span> depthTest = <span class="keyword">true</span>, <span class="keywordtype">bool</span> depthWrite = <span class="keyword">true</span>, <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> depthFunction = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aa2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a>);
<a name="l00364"></a>00364         <span class="keywordtype">void</span> _setDepthBufferCheckEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>);
<a name="l00368"></a>00368         <span class="keywordtype">void</span> _setDepthBufferWriteEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>);
<a name="l00372"></a>00372         <span class="keywordtype">void</span> _setDepthBufferFunction(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aa2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a>);
<a name="l00376"></a>00376         <span class="keywordtype">void</span> _setDepthBias(<span class="keywordtype">float</span> constantBias, <span class="keywordtype">float</span> slopeScaleBias);
<a name="l00380"></a>00380         <span class="keywordtype">void</span> _setColourBufferWriteEnabled(<span class="keywordtype">bool</span> red, <span class="keywordtype">bool</span> green, <span class="keywordtype">bool</span> blue, <span class="keywordtype">bool</span> alpha);
<a name="l00384"></a>00384         <span class="keywordtype">void</span> _setFog(<a class="code" href="group__General.html#ga83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mode, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> density, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> start, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> end);
<a name="l00388"></a>00388         <span class="keywordtype">void</span> _convertProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix,
<a name="l00389"></a>00389             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00393"></a>00393         <span class="keywordtype">void</span> _makeProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, 
<a name="l00394"></a>00394             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00398"></a>00398         <span class="keywordtype">void</span> _makeProjectionMatrix(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, 
<a name="l00399"></a>00399             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00403"></a>00403         <span class="keywordtype">void</span> _makeOrthoMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, 
<a name="l00404"></a>00404             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00408"></a>00408         <span class="keywordtype">void</span> _applyObliqueDepthProjection(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane, 
<a name="l00409"></a>00409             <span class="keywordtype">bool</span> forGpuProgram);
<a name="l00413"></a>00413         <span class="keywordtype">void</span> setClipPlane (<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> A, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> B, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> C, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> D);
<a name="l00417"></a>00417         <span class="keywordtype">void</span> enableClipPlane (<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index, <span class="keywordtype">bool</span> enable);
<a name="l00421"></a>00421         <span class="keywordtype">void</span> _setPolygonMode(<a class="code" href="group__General.html#ga68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> level);
<a name="l00425"></a>00425         <span class="keywordtype">void</span> setStencilCheckEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00429"></a>00429         <span class="keywordtype">void</span> setStencilBufferParams(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aae10ea1648cd8c9bd90bdaccaa11cbc4e">CMPF_ALWAYS_PASS</a>, 
<a name="l00430"></a>00430             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> refValue = 0, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask = 0xFFFFFFFF, 
<a name="l00431"></a>00431             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> stencilFailOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>, 
<a name="l00432"></a>00432             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> depthFailOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l00433"></a>00433             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> passOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>, 
<a name="l00434"></a>00434             <span class="keywordtype">bool</span> twoSidedOperation = <span class="keyword">false</span>);
<a name="l00438"></a>00438         <span class="keywordtype">void</span> _setTextureUnitFiltering(<span class="keywordtype">size_t</span> unit, <a class="code" href="group__General.html#gac1fc36ec2f4df4b2afa9fa39f9c66c06">FilterType</a> ftype, <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> filter);
<a name="l00442"></a>00442         <span class="keywordtype">void</span> _setTextureLayerAnisotropy(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxAnisotropy);
<a name="l00446"></a>00446         <span class="keywordtype">void</span> setVertexDeclaration(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl);
<a name="l00450"></a>00450         <span class="keywordtype">void</span> setVertexBufferBinding(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding);
<a name="l00454"></a>00454         <span class="keywordtype">void</span> _render(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00455"></a>00455 
<a name="l00459"></a>00459         <span class="keywordtype">void</span> bindGpuProgram(<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* prg);
<a name="l00463"></a>00463         <span class="keywordtype">void</span> unbindGpuProgram(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l00467"></a>00467         <span class="keywordtype">void</span> bindGpuProgramParameters(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, 
<a name="l00468"></a>00468             <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> variabilityMask);
<a name="l00472"></a>00472         <span class="keywordtype">void</span> bindGpuProgramPassIterationParameters(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l00476"></a>00476         <span class="keywordtype">void</span> setScissorTest(<span class="keywordtype">bool</span> enabled, <span class="keywordtype">size_t</span> left = 0, <span class="keywordtype">size_t</span> top = 0, <span class="keywordtype">size_t</span> right = 800, <span class="keywordtype">size_t</span> bottom = 600) ;
<a name="l00477"></a>00477         <span class="keywordtype">void</span> clearFrameBuffer(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffers, 
<a name="l00478"></a>00478             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a7f8a06f2a9dd645417c36b560f496c1a">ColourValue::Black</a>, 
<a name="l00479"></a>00479             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> depth = 1.0f, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> stencil = 0);
<a name="l00480"></a>00480         <a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for hardware occlusion...">HardwareOcclusionQuery</a>* createHardwareOcclusionQuery(<span class="keywordtype">void</span>);
<a name="l00481"></a>00481         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getHorizontalTexelOffset(<span class="keywordtype">void</span>);
<a name="l00482"></a>00482         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getVerticalTexelOffset(<span class="keywordtype">void</span>);
<a name="l00483"></a>00483         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMinimumDepthInputValue(<span class="keywordtype">void</span>);
<a name="l00484"></a>00484         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMaximumDepthInputValue(<span class="keywordtype">void</span>);
<a name="l00485"></a>00485         <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mThreadInitMutex)
<a name="l00486"></a>00486         void registerThread();
<a name="l00487"></a>00487         <span class="keywordtype">void</span> unregisterThread();
<a name="l00488"></a>00488         <span class="keywordtype">void</span> preExtraThreadsStarted();
<a name="l00489"></a>00489         <span class="keywordtype">void</span> postExtraThreadsStarted();
<a name="l00490"></a>00490 
<a name="l00491"></a>00491         <span class="comment">// ----------------------------------</span>
<a name="l00492"></a>00492         <span class="comment">// GLRenderSystem specific members</span>
<a name="l00493"></a>00493         <span class="comment">// ----------------------------------</span>
<a name="l00497"></a>00497 <span class="comment"></span>        <span class="keywordtype">void</span> _oneTimeContextInitialization();
<a name="l00500"></a>00500         <span class="keywordtype">void</span> _switchContext(<a class="code" href="classOgre_1_1GLContext.html" title="Class that encapsulates an GL context.">GLContext</a> *context);
<a name="l00504"></a>00504         <span class="keywordtype">void</span> _setRenderTarget(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target);
<a name="l00512"></a>00512         <span class="keywordtype">void</span> _unregisterContext(<a class="code" href="classOgre_1_1GLContext.html" title="Class that encapsulates an GL context.">GLContext</a> *context);
<a name="l00514"></a><a class="code" href="classOgre_1_1GLRenderSystem.html#ae4b1a1a6fd4d2840714ebb9700f4ab25">00514</a>         <a class="code" href="classOgre_1_1GLContext.html" title="Class that encapsulates an GL context.">GLContext</a>* _getMainContext() {<span class="keywordflow">return</span> mMainContext;} 
<a name="l00515"></a>00515 
<a name="l00517"></a>00517         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getDisplayMonitorCount() <span class="keyword">const</span>;
<a name="l00518"></a>00518     };
<a name="l00519"></a>00519 }
<a name="l00520"></a>00520 <span class="preprocessor">#endif</span>
<a name="l00521"></a>00521 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
